#ifndef __data__
#define __data__

//------------------------------------------------------------------------------
// data.h - Описание данных бестиповой программы
//------------------------------------------------------------------------------

//------------------------------------------------------------------------------
// Раздел констант
//------------------------------------------------------------------------------

// Константа, определяющая размер целого числа
int const intSize = sizeof(int);
// Константа, задающая размер для прямоугольника
int const rectSize = 2 * sizeof(int);
// Константа, задающая размер для треугольника
int const trianSize = 3 * sizeof(int);
// Константа, задающая размер для треугольника
int const shapeSize = sizeof(int) + (rectSize >= trianSize ? rectSize : trianSize);
// Константа, определяющая размерность массива фигур
int const maxSize = 10000 * shapeSize;
// Константа, задающая признак прямоугольника
int const RECTANGLE = 1;
// Константа, задающая признак треугольника
int const TRIANGLE = 2;

//------------------------------------------------------------------------------
// Описание используемых функций
//------------------------------------------------------------------------------

// Ввод содержимого контейнера из указанного файла
void InContainer(void *c, int *len, FILE *ifst);
// Случайный ввод содержимого контейнера
void InRndContainer(void *c, int *len, int size);
// Вывод содержимого контейнера в файл
void OutContainer(void *c, int len, FILE *ofst);
// Вычисление суммы периметров всех фигур в контейнере
extern double PerimeterSumContainer(void *c, int len);

#endif
